#include <iostream>
#include <string>
#include <queue>

using namespace std;

struct Team {
    string code;
    int score;
    int index;

    bool operator<(const Team& other) const {
        if (score == other.score) {
            return index > other.index;
        }
        return score < other.score;
    }
};

priority_queue<Team> q;
int n, m, p, e;
int min_e, max_e, sum;
string c;

int main()
{
    cin>>n;
    for (int i = 1; i <= n; i++) {
        Team team;
        cin>>team.code;
        cin>>p;
        min_e = 100;
        max_e = -1;
        sum = 0;
        for (int j = 1; j <= 6; j++) {
            cin>>e;
            if (max_e < e) {
                max_e = e;
            }
            if (min_e > e) {
                min_e = e;
            }
            sum += e;
        }
        sum -= min_e;
        sum -= max_e;
        team.score = p * 10 + sum;
        team.index = i;
        q.push(team);
    }
    cout<<q.top().code<<" "<<q.top().score<<endl;
    q.pop();
    cout<<q.top().code<<" "<<q.top().score<<endl;
    q.pop();
    cout<<q.top().code<<" "<<q.top().score<<endl;
    int cur_score = q.top().score;
    q.pop();
    while (!q.empty() && q.top().score == cur_score) {
        cout<<q.top().code<<" "<<q.top().score<<endl;
        q.pop();
    }
    return 0;
}
