import java.io.IOException;
import java.util.Arrays;
import java.util.Scanner;

public class Vincent5 {

	private static int max(int[] tab) {
		int max = tab[0];
		for (int i = 1; i < tab.length; i++) {
			if (tab[i] > max) {
				max = tab[i];
			}
		}
		return max;
	}

	private static int min(int[] tab) {
		int min = tab[0];
		for (int i = 1; i < tab.length; i++) {
			if (tab[i] < min) {
				min = tab[i];
			}
		}
		return min;
	}

	private static void read() throws IOException {
		Scanner scanner = new Scanner(System.in);
		int N = scanner.nextInt();
		String[] C = new String[N];
		int[] score = new int[N];
		int[] P = new int[N];
		int[] E = new int[6];
		for (int i = 0; i < N; i++) {
			C[i] = scanner.next();
			score[i] = 10 * scanner.nextInt();
			for (int j = 0; j < 6; j++) {
				E[j] = scanner.nextInt();
				score[i] += E[j];
			}
			score[i] -= min(E) + max(E);
		}

		int[] sortedscores = new int[N];
		int[] rank = new int[N];
		for (int i = 0; i < N; i++) {
			sortedscores[i] = score[i];
		}
		Arrays.sort(sortedscores);
		for (int i = 0; i < N; i++) {
			if (score[i] == sortedscores[N - 1]) {
				rank[i] = 1;
			} else if (score[i] == sortedscores[N - 2]) {
				rank[i] = 2;
			} else if (score[i] == sortedscores[N - 3]) {
				rank[i] = 3;
			} else {
				rank[i] = 4;
			}
		}
		for (int r = 1; r <= 3; r++) {
			for (int i = 0; i < N; i++) {
				if (rank[i] == r) {
					System.out.print(C[i]);
					System.out.print(" ");
					System.out.print(score[i]);
					System.out.print("\n");
				}
			}
		}
	}

	public static void main(String[] args) throws IOException {
		read();
	}
}

